# (c) 2000 phil@bluedynamics.com 
#  utility methods to query ZClass internals
#  v1.1.1
#  v1.2.0 added support for nested classes
#  tested with Zope 2.2.2 and 2.2.4 
#  uses Zope internals so changes can be necessary for future Zope releases

import string
from ZClasses import Method

def getZClass(self,product,classname):
    cp=getattr(self,'Control_Panel')
    pr=getattr(cp,'Products')
    prod=getattr(pr,product)

    zc=getattr(prod,classname)
    return zc

def addBaseClass(self,product,classname,baseprod,baseclassname):
    #print 'addBaseClass'
    class1=self.getZClass(product,classname)
    baseclass=self.getZClass(baseprod,baseclassname)
    bases=class1._zbases[1:]
    bases.append(baseclass)
    #print bases
    class1._setBasesHoldOnToYourButts(bases)
    return map(lambda x:str(x),class1._zbases)

def removeBaseClass(self,product,classname,baseprod,baseclassname):
    #print 'removeBaseClass'

    class1=self.getZClass(product,classname)
    baseclass=self.getZClass(baseprod,baseclassname)
    bases=class1._zbases[1:]
    #print 'bases:',bases
    #print 'baseclass:',baseclass
    for c1 in bases:
        #print str(c1),str(baseclass)
        if str(c1)==str(baseclass):
            #print 'found!'
            baseclasstoremove=c1
            break

       
    bases.remove(baseclasstoremove)
    class1._setBasesHoldOnToYourButts(bases)
    #print 'afterbutt'
    
    return map(lambda x:str(x),class1._zbases)

def getClassInfo(self,product,classname):
    "This shows the bases of zclass in product."

    lstr=lambda x:str(x)
    lcl=lambda x:str(x.__class__)
    
    cp=getattr(self,'Control_Panel')
    pr=getattr(cp,'Products')
    #return index_html()
    #app=PARENTS[-1]
    prod=getattr(pr,product)

    #print 'product:',prod
    #print 'zclassname:',classname


    classnames=string.split(classname,'.')
    
    zc=getattr(prod,classnames[0])

    #to find the nested classes
    for cn in classnames[1:]:
        zc=zc._zclass_.__dict__[cn].__of__(None)._ugh[1]

    res={}

    #get the base classes
    res['bases']=zc.ZClassBaseClassNames()
    #res['dict']=map(lstr,zc._zclass_.__dict__.items())
    methods=Method.findMethodIds(zc._zclass_)
#    res['methods']=Method.findMethodIds(zc._zclass_)

    #get nested classes
    

    nested=map(lambda x:string.strip(x),zc.objectValues()[0].objectValues()[0].objectIds(['Z Class']))
    
    #uncomment the following 4 lines if you want nested classes to be fully qualified
    #n1=nested
    #nested=[]
    #for i in n1:
    #    nested.append(classname+'.'+i)


    res['members']=zc.propertysheets.common.objectIds()
    res['methods']=[]
    res['has_a']=[]
    res['nested']=nested

    #extract more info about the methods
    for r in methods:
        try:
           method={}
           m=zc._zclass_.__dict__[r].__of__(None)._ugh[1]
           mc=m.__class__.__name__
           method['name']=m.__name__
           res['methods'].append(method)

           #print m.__name__

           if mc=='PythonMethod' or mc=='PythonScript': 
              method['stereotype']='PythonMethod'
              try: 
                 argcount= m.func_code.co_argcount
                 method['params']=m.func_code.co_varnames[:argcount]  
              except: 
                 method['params']=None
                 
              try:
                 method['doc']=m._t[1]
              except:
                 method['doc']=None
           
              try:
                 method['body']=m._body
              except:
                 method['body']=None

           if mc=='ExternalMethod':
              method['stereotype']='ExternalMethod'
              try:
                  argcount= m.func_code.co_argcount
              except:
                  method['params']=None

              try:
                  method['doc']=m._t[1]
              except:
                  method['doc']=None
           
           if mc=='DTMLMethod':
              method['stereotype']='DTMLMethod'
              try:
                  argcount= m.func_code.co_argcount
                  method['params']=m.func_code.co_varnames[:argcount]  
              except:
                  method['params']=None

              try:
                  method['doc']=m._t[1]
              except:
                  method['doc']=None
           
              try:
                  method['body']=m._body
              except: 
                  method['body']=None

           if mc=='SQL':
              #print 'SQL'
              method['stereotype']='ZSQL Method'
              try:
                  method['params']=string.split(m.arguments_src,' ')
              except:
                  method['params']=None

              #print method['params']
              
              try:
                  method['doc']=m._t[1]
              except:
                  method['doc']=None
           
              try:
                  method['body']=m._body
              except:
                  method['body']=None

        except:
            pass
           #print '--no info--'
 
    return res

def getNestedClassNames(zclass,product,prefix='',classes=[]):
    name=prefix+zclass.__name__
    classes.append((zclass,name,product))
#    classnames=pr.objectIds(['Z Class'])
#    classes=pr.objectValues(['Z Class'])
    nested=zclass.objectValues()[0].objectValues()[0].objectValues(['Z Class'])
    for n in nested:
        getNestedClassNames(n,product,name+'.',classes)
    

def getClassNames(self,product,classes=[]):
                         
    cp=getattr(self,'Control_Panel')
    prs=getattr(cp,'Products')
    pr=getattr(prs,product)

    for cl in pr.objectValues(['Z Class']):
        getNestedClassNames(cl,product,'',classes)
       
    return classes



def getClassInfos(self,product):
   res={}
   products=string.split(product,',')

   classes=[]
   for p in products:
       self.getClassNames(self,p,classes)
       
   metaname=lambda x:x['name']
   #meta2class=lambda x,metamap:metamap[x]
   metamap={}
   
   for cl,clname,productname in classes:
      zcl=cl._zclass_
      zclname=zcl.__name__
      metamap[zcl.meta_type]=zclname

   #print metamap

   for cl,clname,productname in classes:
      zcl=cl._zclass_
      zclname=zcl.__name__
      #print zcl.meta_types
      #print zcl.__name__
      res[zclname]=self.getClassInfo(productname,clname)
      res[zclname]['package']=productname

      #retrieve the  has_a relations      
      try:
          metatypes=map(metaname,zcl.meta_types)
          children=[]
          for m in metatypes:
              try:
                 children.append(metamap[m])
              except:
                 pass #if it is not there it is not there
          #print 'children:',children
          res[zclname]['has_a']=children
      except:
          pass
           

   return res
